%define version       3.04
%define release       1mdk
%define name          omniorb
%define lib_name_orig omniorb
%define lib_major     3
%define lib_name      lib%{lib_name_orig}%{lib_major}
%define prefix        %{_prefix}


# virtual (ie empty) package to enforce naming convention

Summary: Object Request Broker (ORB) from AT&T (CORBA 2.3)
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Libraries
Source0:	omniORB_304.tar.bz2
Source1:	omniEvents_2.1.1.tar.bz2
URL:		http://www.uk.research.att.com/omniORB/
BuildRequires:	python perl tcl tk glibc-devel
Requires:	glibc
Provides:       corba
Prefix:		/usr
BuildRoot:	%{_tmppath}/%{lib_name}-buildroot
Requires: %{lib_name} = %version

%description
omniORB3 is an Object Request Broker (ORB) from AT&T which implements
specification 2.3 of the Common Object Request Broker Architecture (CORBA).


# main package (contains *.so.[major].*, and binaries)

%package -n %{lib_name}
Summary:        Object Request Broker (ORB) from AT&T (CORBA 2.3)
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
BuildArch:      i586

%description -n %{lib_name}
This package contains the library needed to run programs dynamically
linked with %{lib_name_orig}.


# devel part of the bundle

%package -n %{lib_name}-devel
Summary:	Header files and libraries needed for %{name} development
Group:		Development/C++
Requires:       %{lib_name} = %{version}-%{release}
Provides:       libomniorb-devel = %{version}-%{release} %{name}-devel = %{version}-%{release}
BuildArch:      i586

%description -n %{lib_name}-devel
This package includes the header files and libraries needed for
developing programs using %{name}.


# docs and examples are in a separate package

%package -n %{lib_name}-doc
Summary:	Header files and libraries needed for %{name} development
Group:		Development/C++
Requires:	%{name} = %{version}
BuildArch:      noarch

%description -n %{lib_name}-doc
This package includes developers doc including examples.


%prep 


%setup -n omni

# setting architecture to i386+linux-2.x+glibc2.x
perl -pi -e 's/#platform = i586_linux_2.0_glibc2.1/platform = i586_linux_2.0_glibc2.1_gcc2.96/' config/config.mk

# strange include path
perl -pi -e "s|/external_merge||" mk/platforms/i586_linux_2.0_glibc2.1_gcc2.96.mk

# changing the path to python
#not really needed since i586_linux_2.0_glibc2.1_gcc2.96.mk supercedes it
perl -pi -e 's|#PYTHON = /usr/local/bin/python|PYTHON = /usr/bin/python|' mk/platforms/i586_linux_2.0_glibc2.1.mk

# I don't like their default name for their configuration file
perl -pi -e 's|/project/omni/var/omniORB_NEW.cfg|/etc/omniorb.cfg|' mk/platforms/i586_linux_2.0_glibc2.1_gcc2.96.mk
# not needed since it's superceded by the previous, but well, you never know
perl -pi -e 's|/etc/omniORB.cfg|/etc/omniorb.cfg|' mk/platforms/i586_linux_2.0_glibc2.1.mk

# I don't like their path for log files
perl -pi -e 's|/var/omninames|/var/log/omninames|' mk/platforms/i586_linux_2.0_glibc2.1.mk

# changing the path to jar
perl -pi -e 's/JAR = \/usr\/local\/java\/bin\/jar/JAR = \/usr\/bin\/jar/' mk/platforms/i586_linux_2.0_glibc2.1_gcc2.96.mk

# changing the path to classes.zip
perl -pi -e 's/JAVA_SYSTEM_CLASSES = \/usr\/local\/java\/lib\/classes.zip/JAVA_SYSTEM_CLASSES = \/usr\/java\/lib\/classes.zip/' mk/platforms/i586_linux_2.0_glibc2.1_gcc2.96.mk

# Removing rpath definition at link time
perl -p -i -e 's|-Wl\$\(comma\)-rpath\$\(comma\)%|-Wl%|'  mk/platforms/i586_linux_2.0_glibc2.1_gcc2.96.mk
perl -p -i -e 's|-Wl\$\(comma\)-rpath\$\(comma\)%|-Wl%|'  mk/platforms/i586_linux_2.0_glibc2.1.mk

# Adding a hook for RPM_OPT_FLAGS
# ca ne passe pas a cause de gcc et d'une combinaison malheureuse d'option
# perl -pi -e "s|CXXOPTIONS      = -Wall -Wno-unused|CXXOPTIONS      = \\\$\(RPM_OPT_FLAGS\)|" mk/platforms/i586_linux_2.0_glibc2.1.mk

# expanding omniEvents tarball
tar xvjf %SOURCE1 

%make -C src export RPM_OPT_FLAGS="$RPM_OPT_FLAGS"


%install
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT

install -m 755 -d $RPM_BUILD_ROOT%{_bindir}
cp -av bin/i586_linux_2.0_glibc2.1_gcc2.96/* $RPM_BUILD_ROOT%{_bindir}

install -m 755 -d $RPM_BUILD_ROOT%{_libdir}
cp -av lib/i586_linux_2.0_glibc2.1_gcc2.96/* $RPM_BUILD_ROOT%{_libdir}

# it was lost among lib files
mv $RPM_BUILD_ROOT%{_libdir}/omnicpp $RPM_BUILD_ROOT%{_bindir}/
chmod +x $RPM_BUILD_ROOT%{_bindir}/omnicpp

install -m 755 -d $RPM_BUILD_ROOT%{_mandir}
cp -av man/*      $RPM_BUILD_ROOT%{_mandir}

install -m 755 -d $RPM_BUILD_ROOT%{_includedir}/COS/BOA
cp -av include/*  $RPM_BUILD_ROOT%{_includedir}
chmod 755 $RPM_BUILD_ROOT%{_includedir}/COS/BOA
chmod 755 $RPM_BUILD_ROOT%{_includedir}/COS


%clean
[ -z $RPM_BUILD_ROOT ] || rm -rf $RPM_BUILD_ROOT


%post   -n %{lib_name} -p /sbin/ldconfig


%postun -n %{lib_name} -p /sbin/ldconfig


%files
%defattr (-,root,root)
%doc CREDITS bugfixes* ReleaseNote_omniORB_303
%_bindir/*
%attr(644,root,man)  %{_mandir}/man1/*


%files -n %{lib_name}
%defattr (-,root,root)
%{_libdir}/*.so.*


%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc README* CHANGES*
%{_libdir}/*.a
%{_libdir}/*.so
%{_includedir}/*
%attr(644,root,man)  %{_mandir}/man5/*


%files -n %{lib_name}-doc
%defattr(-,root,root)
%doc doc/* 


%changelog
* Mon Sep 03 2001 Lenny Cartier <lenny@mandrakesoft.com> 3.04-1mdk
- 3.04
- split

* Wed Jun 13 2001 HA Quc-Vit <viet@mandrakesoft.com> 3.03-1mdk
- Initial release
- TODO check that the event service is usable
- TODO add the update patch
- TODO add other contrib services
- TODO sort out which shared libraries and binaries are really needed
- TODO setup a working Naming Service
- TODO add a hook for RPM_OPT_FLAGS
